<template>
  <div class="home">
    <app-header></app-header>
    <user-list
      :users="users"
      :ageSelected="ageSelected"
      :genderSelected="genderSelected"
      :nationalitySelected="nationalitySelected"
    ></user-list>
    <app-filters
      @gender-selected="getGenderSelected"
      @age-selected="getAgeSelected"
      @nationality-selected="getNationalitySelected"
    ></app-filters>
  </div>
</template>

<script>
import service from "../services/services.js";
import userList from "../components/UserList";
import AppFilters from "../components/AppFilters";
import AppHeader from "../components/AppHeader";
export default {
  name: "Home",
  data() {
    return {
      users: [],
      genderSelected: "",
      ageSelected: "",
      nationalitySelected: "",
      filtered: []
    };
  },
  components: {
    userList,
    AppFilters,
    AppHeader
  },
  mounted() {
    this.getUsersData();
  },
  methods: {
    getUsersData() {
      service()
        .then(response => {
          response.data.results.map(users => this.users.push(users));
          localStorage.setItem("allUsers", JSON.stringify(this.users));
        })
        .catch(error => {
          throw error;
        });
    },
    getGenderSelected(value) {
      this.genderSelected = value;
    },
    getAgeSelected(value) {
      this.ageSelected = value;
    },
    getNationalitySelected(value) {
      this.nationalitySelected = value;
    }
  }
};
</script>
